﻿Public Class frmHeapTester
   Private _Input As New List(Of Point)
   Private _Rnd As New Random
   Private _PopHeap As LimitedHeap(Of Point)

   Private Sub btGenerate_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btGenerate.Click, btGo.Click, btPop.Click
      Select Case True
         Case sender Is btGenerate
            'generiere einen Haufen Points, mit zufälligem X-Wert
            _Input.Clear()
            For i = 0 To CInt(numInput.Value) - 1
               _Input.Add(New Point(_Rnd.Next, i))
            Next
            lstInput.DataSource = Nothing
            lstInput.DataSource = _Input

         Case sender Is btGo
            'lese die Points in 3 heaps ein - 2 davon limitiert
            Dim isMinHeap = ckIsMinHeap.Checked
            Dim pointSelector = Function(p As Point) p.X

            'normaler Heap
            Dim hp = Heap.FromSelector(pointSelector, isMinHeap)
            For Each pt In _Input
               hp.Push(pt)
            Next
            lstAllResults.DataSource = hp.GetListSorted 'Ausgabe

            'limited Heap
            Dim limit = CInt(numOutput.Value)
            Dim limitedHeap = Heap.FromSelector(pointSelector, isMinHeap, limit)
            For Each pt In _Input
               limitedHeap.Push(pt)
            Next
            lstLimitedResults.DataSource = limitedHeap.GetListSorted 'Ausgabe

            'limited Heap für Einzel-Ausgabe per btPop - selector gleich als Func(Of T, TKey) mitgegeben
            _PopHeap = Heap.FromSelector(Function(p As Point) p.X, isMinHeap, limit)
            For Each pt In _Input
               _PopHeap.Push(pt)
            Next

            Dim sHeap = If(isMinHeap, "MinHeap", "MaxHeap")
            GroupBox1.Text = String.Concat(sHeap, ".GetSortedList() - note: limited ", sHeap, _
               " selects ", If(isMinHeap, "biggest", "smallest"), " Items")

         Case sender Is btPop
            lbPopped.Text = _PopHeap.Pop.ToString 'einzelne Ausgabe
      End Select
   End Sub

End Class
